/*  sum.c 
 *  Jazyk C -- funkce AtoL() a pklad pouit
 */

#include <stdio.h>
#include <ctype.h>

long AtoL(const char *s);         /* deklarace funkce AtoL */

int main(int argc, char *argv[]) {
  long suma = 0;                  /* inicializace */
  int  i;

  for(i=1; i<argc; i++)           /* pro vechny argumenty programu */
    suma += AtoL(argv[i]);        /* st hodnoty */

  printf ("%ld\n", suma);         /* tisk soutu */
  return 0;
}

/*
 *  funkce AtoL - pevede etzec na slo long
 *  v ppad chyby vrac nulu, nekontroluje peteen
 */
long AtoL(const char *s) {             /* definice funkce AtoL */
  long cislo = 0;
  int  zaporne = 0;

  while(isspace(*s)) s++;              /* pesko vodn mezery */

  if(*s=='-' || *s=='+') {             /* zpracuje ppadn znamnko */
    zaporne = (*s=='-');
    s++;
  }
  if(*s=='0') {
    s++;
    if(toupper(*s)=='X') {             /* estnctkov slo */
      s++;
      while(isxdigit(*s)) {            /* dokud jsou slice */
        int c = toupper(*s++);         /* slice */
        cislo = 16 * cislo;
        if(c>='A')
          cislo += c - 'A' + 10;
        else
          cislo += c - '0';
      }
    }
    else {                             /* osmikov slo */
      while( *s > '0' && *s < '8')     /* dokud jsou slice */
        cislo = 8 * cislo + (*s++ - '0');
    }
  }
  else                                 /* destkov slo */
    while(isdigit(*s))                 /* dokud jsou slice */
      cislo = 10 * cislo + (*s++ - '0');

  return zaporne ? -cislo : cislo;
}

/* konec */

