// multinh2.cc -- problmy nsobn ddinosti 
//
// pklad vysvtluje, pro pi konverzi ukazatele na objekt
// na nkterou z bzovch td pi nsobn ddinosti
// dojde ke zmn hodnoty ukazatele

#include <iostream>
using namespace std;

class A {
  int a;
 public:
  A(int x): a(x) { 
    cout << "konstruktor A(" << a << ") this = " << this << endl; 
  }
  ~A()       { cout << "destruktor  A" << endl;   }
};

class B: public A {
  int b;
 public:
  B(): A(10) { cout << "konstruktor B() this = " << this << endl; }
  ~B()       { cout << "destruktor  B" << endl;   }
};

class C {
  int c;
 public:
  C()        { cout << "konstruktor C() this = " << this << endl; }
  ~C()       { cout << "destruktor  C" << endl;   }
};


class D: public B, public C {
   int d;
 public:
   D()       { cout << "konstruktor D() this = " << this << endl; }
   ~D()      { cout << "destruktor  D" << endl;   }
};


int main() {
  D d;
  D *pd = &d;
  // nsleduj konverze na ukazatele na podobjekty objektu d
  B *pb = pd; // implicitn konverze me mnit hodnotu ukazatele!
  C *pc = pd; // implicitn konverze me mnit hodnotu ukazatele!
  //
  // struktura objektu:
  //
  //  +--------------+ <---- pd, pb
  //  || zddno z A |
  //  +|-------------+
  //  || zddno z B |
  //  +--------------+ <---- pc
  //  | zddno z C  |
  //  +--------------+
  //  | D            |
  //  +--------------+
  //
  cout << "adresa objektu D " << pd << endl;
  cout << "adresa objektu D po konverzi na B* " << pb << endl;
  cout << "adresa objektu D po konverzi na C* " << pc << endl;  
  return 0;
}
